<template>
    <v-container>
        <v-row>
            <v-col cols="12" sm="8" offset="2">
                <v-data-table :items="moyens" :headers="headers" hide-default-footer>
                    <template v-slot:item.actions="{ item }">
                        <v-icon small class="mr-2" @click="editItem(item)">mdi-pencil</v-icon>
                        <v-icon small @click="deleteMoyen(item)">mdi-delete</v-icon>
                    </template>
                </v-data-table>
                <div>
                    <v-dialog v-model="dialog" max-width="500px">
                        <template v-slot:activator="{ on }">
                            <v-btn color="green" dark class="mb-2" v-on="on">Ajouter un moyen</v-btn>
                        </template>
                        <v-card>
                            <v-card-title>
                                <span class="headline">{{ formTitle }}</span>
                            </v-card-title>
                            <v-card-text>
                                <v-container>
                                    <v-row>
                                        <v-col cols="12" sm="12" md="12">
                                            <v-text-field v-model="editedMoyen.title" label="Titre"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="6" md="6">
                                            <v-text-field type="number" v-model.number="editedMoyen.priceBzh"
                                                          label="Prix Bretagne"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="6" md="6">
                                            <v-text-field type="number" v-model.number="editedMoyen.priceCentre"
                                                          label="Prix Centre"></v-text-field>
                                        </v-col>
                                    </v-row>
                                </v-container>
                            </v-card-text>

                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="brown darken-1" text @click="close">Annuler</v-btn>
                                <v-btn color="brown darken-1" text @click="save">Enregistrer</v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </div>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
    import axios from 'axios'

    export default {
        name: "MoyensManager",
        data: () => ({
            dialog: false,
            headers: [
                {
                    text: 'Titre',
                    value: 'title'
                },
                {
                    text: 'Prix Bretagne',
                    value: 'priceBzh',
                    align: 'center'
                },
                {
                    text: 'Prix Centre',
                    value: 'priceCentre',
                    align: 'center'
                },
                {
                    text: 'Actions',
                    value: 'actions',
                    align: 'center'
                }
            ],
            moyens: [],
            defaultMoyen: {
                id: null,
                title: '',
                priceBzh: 0,
                priceCentre: 0
            },
            editedIndex: -1,
            editedMoyen: {
                id: null,
                title: '',
                priceBzh: 0,
                priceCentre: 0
            },
        }),
        beforeMount() {
            axios.get("/fetchMoyens").then((res) => this.moyens = res.data);
        },
        methods: {
            close() {
                this.dialog = false;
                setTimeout(() => {
                    this.editedMoyen = Object.assign({}, this.defaultMoyen);
                    this.editedIndex = -1
                }, 300)

            },
            save() {
                axios.post("/updateOrInsertMoyen", JSON.stringify(this.editedMoyen)).then((res) => this.editedMoyen.id = res.data.id);
                if (this.editedIndex > -1) {
                    Object.assign(this.moyens[this.editedIndex], this.editedMoyen);
                } else {
                    this.moyens.push(this.editedMoyen);
                }
                this.close()
            },
            editItem(item) {
                this.editedIndex = this.moyens.indexOf(item);
                this.editedMoyen = Object.assign({}, item);
                this.dialog = true
            },
            deleteMoyen(item) {
                //todo do delete
                console.log(item)
            }
        },
        computed: {
            formTitle() {
                return this.editedIndex === -1 ? 'Nouveau Moyen' : 'Edition'
            },
        },
        watch: {
            dialog(val) {
                val || this.close()
            },
        },
    }


</script>

<style scoped>

</style>